From ef7e683a2b416d6ef5ee79c7534578cb9f47c802 Mon Sep 17 00:00:00 2001
From: Ralph Bean <rbean@redhat.com>
Date: Jul 07 2015 19:52:37 +0000
Subject: [PATCH 173/254] Try to match the stats widget to the mockup.


---

diff --git a/hubs/app.py b/hubs/app.py
index bca015e..cac231f 100644
--- a/hubs/app.py
+++ b/hubs/app.py
@@ -50,6 +50,12 @@ class CustomJSONEncoder(flask.json.JSONEncoder):
 app.json_encoder = CustomJSONEncoder
 
 
+@app.teardown_request
+def shutdown_session(exception=None):
+    """ Remove the DB session at the end of each request. """
+    session.remove()
+
+
 @app.route('/')
 def index():
     if not flask.g.auth.logged_in:
@@ -249,6 +255,27 @@ def hub_unsubscribe(hub):
     session.commit()
     return flask.redirect(flask.url_for('hub', name=hub.name))
 
+@app.route('/api/hub/<hub>/star', methods=['POST'])
+@login_required
+def hub_star(hub):
+    hub = get_hub(session, hub)
+    user = hubs.models.User.by_openid(session, flask.g.auth.openid)
+    hub.subscribe(session, user, role='stargazer')
+    session.commit()
+    return flask.redirect(flask.url_for('hub', name=hub.name))
+
+@app.route('/api/hub/<hub>/unstar', methods=['POST'])
+@login_required
+def hub_unstar(hub):
+    hub = get_hub(session, hub)
+    user = hubs.models.User.by_openid(session, flask.g.auth.openid)
+    try:
+        hub.unsubscribe(session, user, role='stargazer')
+    except KeyError:
+        return flask.abort(400)
+    session.commit()
+    return flask.redirect(flask.url_for('hub', name=hub.name))
+
 @app.route('/api/hub/<hub>/join', methods=['POST'])
 @login_required
 def hub_join(hub):
diff --git a/hubs/models.py b/hubs/models.py
index ff117ab..ef97536 100644
--- a/hubs/models.py
+++ b/hubs/models.py
@@ -83,7 +83,7 @@ def init(db_url, debug=False, create=False):
     return scoped_session(sessionmaker(bind=engine))
 
 
-roles = ['subscriber', 'member', 'owner']
+roles = ['subscriber', 'member', 'owner', 'stargazer']
 
 
 class Association(BASE):
@@ -95,7 +95,7 @@ class Association(BASE):
     user_id = sa.Column(sa.Text,
                         sa.ForeignKey('users.openid'),
                         primary_key=True)
-    role = sa.Column(sa.Enum(*roles), nullable=False)
+    role = sa.Column(sa.Enum(*roles), primary_key=True)
 
     user = relation("User", backref="associations")
     hub = relation("Hub", backref="associations")
@@ -126,6 +126,7 @@ class Hub(BASE):
     def owners(self):
         return [assoc.user for assoc in self.associations
                 if assoc.role == 'owner']
+
     @property
     def members(self):
         return [assoc.user for assoc in self.associations
@@ -136,6 +137,11 @@ class Hub(BASE):
         return [assoc.user for assoc in self.associations
                 if assoc.role == 'subscriber']
 
+    @property
+    def stargazers(self):
+        return [assoc.user for assoc in self.associations
+                if assoc.role == 'stargazer']
+
     def subscribe(self, session, user, role='subscriber'):
         """ Subscribe a user to this hub. """
         # TODO -- add logic here to manage not adding the user multiple
@@ -284,6 +290,19 @@ class User(BASE):
                 if assoc.role == 'subscriber']
 
     @property
+    def starred_hubs(self):
+        return [assoc.hub for assoc in self.associations
+                if assoc.role == 'stargazer']
+
+    @property
+    def bookmarks(self):
+        # TODO -- someday make this editable/configurable.
+        return sorted(list(set([assoc.hub for assoc in self.associations
+                if assoc.role == 'member'
+                or assoc.role == 'subscriber'
+                or assoc.role == 'owner'])))
+
+    @property
     def username(self):
         return self.openid.split('.')[0]
 
diff --git a/hubs/widgets/stats.py b/hubs/widgets/stats.py
index ee00da2..228d60f 100644
--- a/hubs/widgets/stats.py
+++ b/hubs/widgets/stats.py
@@ -6,35 +6,46 @@ import jinja2
 
 chrome = panel()
 template = jinja2.Template("""
-<div class="stats-container">
+<div class="stats-container row">
+<div class="col-md-7">
   <table class="stats-table">
     <tr><th>Members</th><th>Subscribers</th></tr>
     <tr class="text-info"><td>{{members | length}}</td><td class="text-right">{{subscribers | length}}</td></tr>
   </table>
+</div>
+<div class="col-md-5">
+  <ul class="list-unstyled">
+  {% if g.auth.nickname in subscribers %}
+  <li><form action="{{hub_unsubscribe_url}}" method="POST">
+      <button class="btn btn-info"><span class="glyphicon glyphicon-remove-sign" aria-hidden="true"></span> Unsubscribe</button>
+  </form></li>
+  {% else %}
+  <li><form action="{{hub_subscribe_url}}" method="POST">
+      <button class="btn btn-default"><span class="glyphicon glyphicon-ok-sign" aria-hidden="true"></span> Subscribe</button>
+  </form></li>
+  {% endif %}
+
+  {% if g.auth.nickname in stargazers %}
+  <li><form action="{{hub_unstar_url}}" method="POST">
+      <button class="btn btn-info"><span class="glyphicon glyphicon-remove-sign" aria-hidden="true"></span> Unstar Hub</button>
+  </form></li>
+  {% else %}
+  <li><form action="{{hub_star_url}}" method="POST">
+      <button class="btn btn-default"><span class="glyphicon glyphicon-ok-sign" aria-hidden="true"></span> Star Hub</button>
+  </form></li>
+  {% endif %}
 
-  {% if g.auth.logged_in %}
-    <div class="pull-right">
-    {% if g.auth.nickname in members %}
-    <form action="{{hub_leave_url}}" method="POST">
-        <button class="btn btn-danger"><span class="glyphicon glyphicon-remove-sign" aria-hidden="true"></span> Leave Hub</button>
-    </form>
-    {% elif g.auth.nickname in subscribers %}
-    <form action="{{hub_unsubscribe_url}}" method="POST">
-        <button class="btn btn-warning"><span class="glyphicon glyphicon-remove-sign" aria-hidden="true"></span> Unsubscribe</button>
-    </form>
-    {% else %}
-    <form action="{{hub_subscribe_url}}" method="POST">
-        <button class="btn btn-info"><span class="glyphicon glyphicon-ok-sign" aria-hidden="true"></span> Subscribe</button>
-    </form>
-    {% endif %}
-    </div>
+  {% if g.auth.nickname in members %}
+  <li><form action="{{hub_leave_url}}" method="POST">
+      <button class="btn btn-info"><span class="glyphicon glyphicon-remove-sign" aria-hidden="true"></span> Leave Hub</button>
+  </form></li>
   {% else %}
-    <div class="pull-right">
-        <form action="{{hub_subscribe_url}}" method="POST">
-            <button class="btn btn-info"><span class="glyphicon glyphicon-ok-sign" aria-hidden="true"></span> Subscribe</button>
-        </form>
-    </div>
+  <li><form action="{{hub_join_url}}" method="POST">
+      <button class="btn btn-default"><span class="glyphicon glyphicon-ok-sign" aria-hidden="true"></span> Join Hub</button>
+  </form></li>
   {% endif %}
+  </ul>
+</div>
 </div>
 """)
 
@@ -44,8 +55,12 @@ def data(session, widget):
         owners=[u.username for u in widget.hub.owners],
         members=[u.username for u in widget.hub.members],
         subscribers=[u.username for u in widget.hub.subscribers],
+        stargazers=[u.username for u in widget.hub.stargazers],
+
         hub_leave_url=flask.url_for('hub_leave', hub=widget.hub.name),
         hub_join_url=flask.url_for('hub_join', hub=widget.hub.name),
+        hub_unstar_url=flask.url_for('hub_unstar', hub=widget.hub.name),
+        hub_star_url=flask.url_for('hub_star', hub=widget.hub.name),
         hub_subscribe_url=flask.url_for('hub_subscribe', hub=widget.hub.name),
         hub_unsubscribe_url=flask.url_for('hub_unsubscribe', hub=widget.hub.name),
     )

